<?php
/***********************************************************************/
/*                                                                     */  
/*  sb+ is a package for useing of Saman Bank SMP in your site         */
/*  for electronics payment with all banks in shetab netwotk           */
/*  Use of SMP protocol for execution payment method                   */
/*  Special Tanks of Dietrich Ayala & Scott Nichol (nusoap)            */
/*                                                                     */
/***********************************************************************/
/*                                                                     */
/*  @version $Page: sb+.php,v 0.3 2006/03/16 00:15 Farhad zare Exp $   */
/*  @package sb+                                                       */             
/*  @author Farhad Zare ( farhad[at]persianoc[dot]com )                */
/*  @copyright (C) 2005-2009 Farhad zare                               */
/*  @license http://www.gnu.org/copyleft/gpl.html GNU/GPL              */
/*                                                                     */
/***********************************************************************/

//define required variables
define("_INCLUDE_DIR", "includes/classes/lib/");           //Path of required file for include (with full slash)
define("MERCHANT_ID", MODULE_PAYMENT_SB24_MID);            //Merchant ID for settlement money.You must get one from Saman Bank Network
define("MERCHANT_PASSWORD", MODULE_PAYMENT_SB24_MPASS);    //Password of Merchant ID for return money to customer.
define("SB24_STYLE_URL", MODULE_PAYMENT_SB24_STYLE_PATH);  //A XML file contain parameters for change page aspect of bank network
define("SB24_TABLE_RESERVATION", TABLE_SB24_RESERVATION);  //Name of table in mysql database for store reservation data
define("SB24_TABLE_ERECEIPT", TABLE_SB24_ERECEIPT);        //Name of table in mysql database for store electronic receipt data
define("SB24_TABLE_RETURNLOG", TABLE_SB24_RETURNLOG);      //Name of table in mysql database for store all money return details

require_once(_INCLUDE_DIR."nusoap.php");

class sb24style {

  var $TableBorderColor = '';           //Color of table border
  var $TableBGColor = '';               //Color of center table background
  var $PageBGColor = '';                //Color of page background
  var $PageBorderColor = '';            //Color of page border
  var $TitleFont = '';                  //Page Main Title font's
  var $TitleColor = '';                 //Color of Page Main Title's
  var $TitleSize = '';                  //Size of Page Main Title's
  var $TextFont = '';                   //Comments and parameters values font
  var $TextColor = '';                  //Color of comments and parameters values
  var $TextSize = '';                   //Size of comments and parameters values
  var $TypeTextFont = '';               //Parameters Title font
  var $TypeTextColor= '';               //Color of Parameters title
  var $TypeTextSize = '';               //Size of Parameters title
  var $LogoURL = '';                    //Merchant Logo URL
  var $error = False;
  var $parser_error = '';
  var $xml_list_elements = array();
  var $xml_data = array();
  
  function sb24style() {
    if(!file_exists(SB24_STYLE_URL)) {
      $this->error = True;
      $this->parser_error = "XML File not found!";
      error_log($this->parser_error."\n",3,"includes/error.log");
    } else {
      $string = file_get_contents(SB24_STYLE_URL);
      $this->XmlParser($string);
      if ($this->error == false) {
        $this->set_variable();
      } else {
        error_log($this->parser_error."\n",3,"includes/error.log");
      }
    }
  }
    

 /**
  * XmlParser -- parse XML into an associative array
  *
  * Takes a string of XML as input and returns an associative array. If
  * an error occurs, false is returned and the global $parser_error describes
  * the error in detail.
  *
  * @param string $string A string of XML
  * @return boolean|array  Returns false on error or associative array on success
  *
  */
  function XmlParser($string) {
    $values=array();

    // Create parser
    $p = xml_parser_create("UTF-8");
    xml_parser_set_option($p,XML_OPTION_CASE_FOLDING,false);
    xml_parser_set_option($p,XML_OPTION_SKIP_WHITE,true);

    // Parse into array structure
    $rc = xml_parse_into_struct($p,$string,$values);

    if (!$rc)
    {
      $this->error = True;
      $errorcode = xml_get_error_code($p);
      $errstring = xml_error_string($errorcode);
      $byte= xml_get_current_byte_index($p);
      $this->parser_error = "XML PARSER ERROR: Error Code= $errorcode, Explanation= $errstring, Byte Number= $byte";
      xml_parser_free($p);
    } else {
      xml_parser_free($p);

      // We store our path here
      $hash_stack = array();

      // This is our target
      foreach ($values as $val) {

        switch ($val['type']) {
          case 'open': // Start array structure
            array_push($hash_stack, $val['tag']);
            $valarg= (isset($val['attributes'])) ? $val['attributes'] : null;
            $this->xml_data = $this->composeArray($this->xml_data, $hash_stack, $valarg);
            break;

          case 'close': // All done with this element
            array_pop($hash_stack);
            break;

          case 'complete':
            array_push($hash_stack, $val['tag']);
            $valarg=(isset($val['value']))? $val['value'] : null;
            // handle all attributes except those in 'open' container tags
            if (isset($val['attributes'])) {
              $temparr=array($val['tag'] => $valarg);
              $valarg=array_merge($val['attributes'], $temparr);
            };
            $this->xml_data = $this->composeArray($this->xml_data, $hash_stack, $valarg);
            array_pop($hash_stack);
            break;

          default:
            // Ignoring CDATA type
        }
      }
    }
  }

 /**
  * A private helper function for XmlParser(). Parses repeated
  * XML values into arrays.
  *
  * @param array $array
  * @param array $elements
  * @param string $value
  * @return array
  */
  function &composeArray($array, $elements, $value) {

    // Get current element
    $element = array_shift($elements);

    // Are there more elements?
    if(sizeof($elements) > 0) {
      $array[$element] = &$this->composeArray($array[$element], $elements, $value);
    } else {
      $array[$element] = $value;
      $this->xml_list_elements[] = $element;
    }

    return $array;
  }

  function set_variable() {
    for($i=1;$i<sizeof($this->xml_list_elements);$i++) {
      $str = $this->xml_list_elements[$i];
      if(isset($this->$str)) {
        $this->$str = $this->xml_data["style"][$str];
      } else {
        $this->error = TRUE;
        $this->parser_error = "XML Data error: " .$str. " isn't allowed element.\n";
        error_log($this->parser_error."\n",3,"includes/error.log");
      }
    }
  }
  
  function create_post() {
    $hidden = '';
    for ($i=1;$i<sizeof($this->xml_list_elements);$i++) {
      $str = $this->xml_list_elements[$i];
      $hidden .= tep_draw_hidden_field($str, $this->$str);
    }
    return $hidden;
  }
}

class sb24out {

  var $amount = 0;                       //Amount of money for transaction
  var $reservation = '';                 //A security number for access user
  var $merchantID = MERCHANT_ID;         //Your Merchant ID of Saman bank
  var $redirect = '';                    //User redirect to this URL after compietion transaction
  var $style;                            //new style class for payment page
  var $setstyle = False;                 //If you defined new style for payment page this variable is True
  var $orderid;                          //ID of order for wist user and order after user redirect
  var $error_ok = False;
  var $errorstr = array();
  var $error_save_handele = 0;
  
  function sb24out($oid, $amo) {
    if ($amo <= 0) {
      $this->error_ok = True;
      $this->errorstr[] = "Payment error: Amount cannot be eaqual to or less than zero. ";
      $this->save_error();
    } else {
      $this->amount = $amo;
    }
    if ($oid <= 0) {
      $this->error_ok = True;
      $this->errorstr[] = "Payment error: You must enter a valid value for orderid of this payment.";
      $this->save_error();
    } else {
      $this->orderid = $oid;
    }
  }
  
  function set_redirect($url) {
  	$allowed_schemes = array('http', 'https');
  	
  	if (preg_match(
        '&^(?:([a-z][-+.a-z0-9]*):)?                                         # 1. scheme
         (?://                                                               # authority start
         (?:((?:%[0-9a-f]{2}|[-a-z0-9_.!~*\'();:\&=+$,])*)@)?                # 2. authority-userinfo
         (?:((?:[a-z0-9](?:[-a-z0-9]*[a-z0-9])?\.)*[a-z](?:[a-z0-9]+)?\.?)   # 3. authority-hostname OR
         |([0-9]{1,3}(?:\.[0-9]{1,3}){3}))                                   # 4. authority-ipv4
         (?::([0-9]*))?)                                                     # 5. authority-port
         ((?:/(?:%[0-9a-f]{2}|[-a-z0-9_.!~*\'():@\&=+$,;])*)*/?)?            # 6. path
         (?:\?([^#]*))?                                                      # 7. query
         (?:\#((?:%[0-9a-f]{2}|[-a-z0-9_.!~*\'();/?:@\&=+$,])*))?            # 8. fragment
         $&xi', $url, $matches)) {
      
      $scheme = isset($matches[1]) ? $matches[1] : '';
      $authority = isset($matches[3]) ? $matches[3] : '' ;
      if (!in_array($scheme,$allowed_schemes)) {
        $url_is_valid = false;
      }
      if (!empty($matches[4])) {
        $parts = explode('.', $matches[4]);
        foreach ($parts as $part) {
          if ($part > 255) {
            $url_is_valid = false;
          }
        }
      }
  	} else {
  	  $url_is_valid = false;
  	}
  	
    if ($url_is_valid === false) {
      $this->error_ok = True;
      $this->errorstr[] = "Payment error: Invalid redirect URL.";
      $this->save_error();
    } else {
      $this->redirect = $url;
    }
  }
  
  function set_style() {
    if ($this->setstyle == True) {
      return True;
    } else {
      $this->style = new sb24style;
      if ($this->style->error == True) {
        return False;
      } else {
        $this->setstyle = True;
        return True;
      }
    }
  }
  
  function create() {

    if(trim($this->merchantID) == '') {
      $this->error_ok = True;
      $this->errorstr[] = "Payment error: you must enter a mechant id for post to transaction server.";
    }
    if(trim($this->redirect) == '') {
      $this->error_ok = True;
      $this->errorstr[] = "Payment error: You must enter a redirect URL for redirect user to your site after compietion transaction";
    }
    if(intval($this->amount) <= 0) {
      $this->error_ok = True;
      $this->errorstr[] = "Payment error: Amount cannot be eaqual to or less than zero. ";
    }
    if(intval($this->orderid) <= 0) {
      $this->error_ok = True;
      $this->errorstr[] = "Payment error: You must enter a valid value for orderid of this payment.";
    }
    if($this->create_reservation() == False) {
      $this->error_ok == True;
    }
    if($this->error_ok == True) {
      $this->save_error();
      return False;
    }

    if(!@tep_db_query("INSERT INTO " .SB24_TABLE_RESERVATION. " VALUES('','" .$this->orderid. "','" .$this->amount. "','" .$this->reservation. "')")) {
      $this->error_ok = True;
      $this->errorstr[] = "MySQL error: you can't insert data to database.";
      $this->save_error();
      return False;
    }
    
    $output .= tep_draw_hidden_field('Amount', $this->amount);
    $output .= tep_draw_hidden_field('ResNum', $this->reservation);
    $output .= tep_draw_hidden_field('MID', $this->merchantID);
    $output .= tep_draw_hidden_field('RedirectURL', $this->redirect);

    if ($this->setstyle == True) {
      $output .= $this->style->create_post();
    }

    return $output;
  }
  
  function create_reservation() {
    if(tep_db_query("SELECT * FROM " .SB24_TABLE_RESERVATION)) {
      while(True) {
        $randreser = generatePassword(20,true,true,true,false);
        $randreser = md5($randreser);
        if(!tep_db_num_rows(tep_db_query("SELECT id FROM " .SB24_TABLE_RESERVATION. " WHERE res_number='$randreser'"))) {
          break;
        }
      }
      $this->reservation = $randreser;
      return True;
    } else {
      $this->error_ok = True;
      $this->errorstr[] = "MySQL error: reservation table not found in database.";
    }
    $this->save_error();
    return False;
  }
  
  function save_error() {
    if ($this->error_ok == True) {
      for ($i=$this->error_save_handele;$i<sizeof($this->errorstr);$i++) {
        error_log($this->errorstr[$i]."\n",3,"includes/error.log");
      }
      $this->error_save_handele = $i;
    } else {
      $this->error_save_handele = 0;
    }
  }
  
}

class sb24get {

  var $reservation = '';                 //Security number for access user
  var $reference = '0';                    //Unique receipt Number from bank
  var $state = '';                       //state of transaction
  var $amount = 0;                       //Amount of payment
  var $orderid = 0;                      //ID of order for wist user and order
  var $error_ok = False;
  var $errorstr = array();
  var $error_save_handele = 0;
  var $redirect = False;                 //user redirected where?
  var $action = '';
  var $verifyresult = 0;                 //Result of verify web method for check transcation
  
  function sb24get() {
    $State = '';
    $ResNum = '';
    if(isset($_GET['send']) AND $_GET['send'] == 'True') {
      foreach ($_GET as $key => $value) {
        $$key = $value;
      }
    } else {
      $State = '';
      $RefNum = '';
      $ResNum = '';
      foreach ($_POST as $key => $value) {
        $$key = $value;
      }
      if($RefNum == '' AND $State != '' AND $ResNum != '') {
        $RefNum = '0';	
      }
    }

    if(isset($_GET['send']) AND ($_GET['send'] == 'True') AND ($State == 'Canceled By User') AND ($ResNum != '')) {
      $this->redirect = 'Site';
    } elseif (isset($_GET['send']) AND $_GET['send'] == True) {
      $this->error_ok = True;
      $this->errorstr[] = "Not allowed see this page. Maybe attempt for Carck.";
      $this->save_error();
    }
  
    if($this->error_ok == False) {
      if((isset($State) AND $State != '') AND (isset($ResNum) AND $ResNum != '') AND (isset($RefNum) AND $RefNum != '')) {
        $this->redirect = 'Bank';
      } elseif($this->redirect != 'Site') {
        $this->error_ok = True;
        $this->errorstr[] = "Requriement parameters missed. Maybe attempt for Carck.";
        $this->save_error();
      }

      if($this->redirect == 'Site' OR $this->redirect == 'Bank') {
        $this->state = $State;
        $this->reservation = $ResNum;
      }
      if($this->redirect == 'Bank') {
        $this->reference = $RefNum;
      }
    }
  }
  
  function action() {

    if($this->redirect == "Site" AND $this->error_ok == False) {
      if($this->state = "Canceled By User") {
        $this->action = "Delreser";
        $action_state = $this->run_action();
        if($action_state == True) {
          return "عمليات پرداخت پول با موفقيت لغو شد. اگر مجدداً قصد پرداخت پول را داشتيد بايد مراحل را دوباره طى نماييد.";
        } else {
          return "درخواست شما مبنى در لغو عمليات پرداخت پول غيرمعتبر مى باشد.";
        }
      }
    } elseif($this->redirect == "Bank" AND $this->error_ok == False) {
      if($this->state == "OK") {
        $this->action = "CheckRefer";
        $action_state = $this->run_action();
        if($action_state == True) {
          $this->action = "Checkreser";
          $action_state = $this->run_action();
          if ($action_state == True) {
            $this->action = "VerifyMethod";
            $action_state = $this->run_action();
            $this->store();
            if ($action_state == True) {
              if($this->verifyresult == $this->amount) {
                return "پرداخت با موفقيت از طرف بانک تائيد شد.";
              } elseif ($this->verifyresult < $this->amount) {
              	
                $back = new sb24return($this->reference);
                $backres = $back->back($this->verifyresult);
                if($backres == True) {
                  return "مبلغ پرداختی شما کمتر از مبلغ کل سفارش بود بنابراین کل مبلغ پرداختی توسط سایت با موفقیت برگشت زده شد.";
                } else {
                  return "مبلغ پرداختی شما کمتر از مبلغ کل سفارش است و سایت قادر به برگشت زدن کل مبلغ پرداختی شما نمی باشد. لطفا با مدیریت سایت تماس حاصل فرمایید.";
                }
                
              } elseif ($this->verifyresult > $this->amount) {
                
                $back = new sb24return($this->reference);
                $backres = $back->back($this->verifyresult - $this->amount);
                if($backres == True) {
                  return "مبلغ پرداختی شما بیشتر از مبلغ کل سفارش بود بنابراین مابه التفاوت 2 مبلغ توسط سایت با موفقیت برگشت زده شد.";
                } else {
                  return "مبلغ پرداختی شما بیشتر از مبلغ کل سفارش است و سایت قادر به برگشت زدن مابه التفاوت 2 مبلغ نمی باشد. لطفا هرچه سریعتر با مدیریت سایت تماس حاصل فرمایید.";
                }
                
              }
            } else {
              if ( $this->verifyresult < 0 AND $this->verifyresult > -19 ) {
                return $this->show_msg($this->verifyresult,2);
              } else {
                return "خطا ايجاد شده قابل شناسايى نيست. لطفا با مديريت سايت تماس بگيريد.";
              }
            }
            
          } else {
            return "اطلاعات دريافتى از طرف بانک غيرمعتبر مى باشد. سيستم قادر به شناسايى شما نمى باشد.";
          }
        } else {
          return "رسيد دريافتى از طرف بانک قبلا براى پرداخت استفاده شده است. بنابراين شما قادر به استفاده مجدد از اين رسيد نمى باشيد.";
        }
      }elseif($this->state == "Canceled By User" OR $this->state == "InvalidAmount" OR $this->state == "InvalidTransaction" OR $this->state == "Bad Card Number" OR $this->state == "NoSuchIssuer" OR $this->state == "ExpiredCardPickUp" OR $this->state == "SuspectedCardPickUp" OR $this->state == "AllowablePINTriesExceededPickUp" OR $this->state == "IncorrectPIN" OR $this->state == "ExceedsWithdrawalAmountLimit" OR $this->state == "TransactionCannotBeCompleted" OR $this->state == "ResponseReceivedTooLate" OR $this->state == "SuspectedFraudPickUp" OR $this->state == "NoSufficientFunds" OR $this->state == "IssuerDownSlm") {
        $this->action = "Delreser";
        $this->run_action();
        return $this->show_msg($this->state, 1);
      } else {
        $this->action = "Delreser";
        $this->run_action();
        return "خطا ايجاد شده قابل شناسايى نيست. لطفا با مديريت سايت تماس بگيريد.";
      }
    } else {
      return "شما اجازه دسترسى به اين صفحه را نداريد.";
    }
  }
  
  function show_msg($key,$type = 1) {

    $error_msg = array("Canceled By User"=>"عمليات پرداخت پول توسط شما لغو شده است.",
                       "InvalidAmount"=>"مبلغ سند برگشتى از مبلغ قابل پرداخت بيشتر است.",
                       "InvalidTransaction"=>"درخواست برگشت يک پرداخت رسيده است, درحالى که پرداخت اصلى پيدا نمى شود.",
                       "Bad Card Number"=>"شماره کارت اشتباه مى باشد.",
                       "NoSuchIssuer"=>"چنين صادرکننده کارتى وجود ندارد.",
                       "ExpiredCardPickUp"=>"از تاريخ انقضاى کارت گذشته است و کارت ديگر معتبر نيست.",
                       "SuspectedCardPickUp"=>"رمز کارت (PIN) به تعداد 4 بار يا بيشتر اشتباه وارد شده است.",
                       "AllowablePINTriesExceededPickUp"=>"رمز کارت (PIN) 3 مرتبه اشتباه وارد شده است در نتيجه کارت شما غيرفعال خواهد شد.",
                       "IncorrectPIN"=>"شما رمز کارت (PIN)را اشتباه وارد کرده ايد.",
                       "ExceedsWithdrawalAmountLimit"=>"مبلغ بيش از سقف پرداخت مى باشد.",
                       "TransactionCannotBeCompleted"=>"پرداخت Authorize شده است (شماره PIN و PAN درست مى باشند) ولى امکان سند خوردن وجود ندارد.",
                       "ResponseReceivedTooLate"=>"تراکنش در شبکه بانکى Timeout خورده است.",
                       "SuspectedFraudPickUp"=>"شما يا فيلد مربوط به CVV2 ويا فيلد مربوط به ExpDate را اشتباه وارد کرده ايد. (شايد هم اصلا وارد نکرده ايد)",
                       "NoSufficientFunds"=>"به اندازه کافى موجودى در حساب شما وجود ندارد.",
                       "IssuerDownSlm"=>"سيستم کارت بانک صادرکننده در وضعيت عملياتى نيست."
    );
    
    $web_method_error = array("-1"=>"خطاى داخلى شبکه مالى",
                              "-2"=>"سپرده ها برابر نيستند.",
                              "-3"=>"ورودى ها حاوى کاراکترهاى غيرمجاز مى باشند.",
                              "-4"=>"Merchant Authentication Failed (کلمه عبور يا کد فروشنده اشتباه است).",
                              "-5"=>"Database Exception",
                              "-6"=>"سند قبلا برگشت کامل يافته است.",
                              "-7"=>"رسيد ديجيتالى تهى است.",
                              "-8"=>"طول ورودى ها بيشتر از حد مجاز است.",
                              "-9"=>"وجود کاراکترهاى غيرمجاز در در مبلغ برگشتى.",
                              "-10"=>"رسيد ديجيتالى به صورت Base64 نيست (حاوى کاراکترهاى غيرمجاز مى باشد).",
                              "-11"=>"طول ورودى ها کمتر از حد مجاز است.",
                              "-12"=>"مبلغ برگشتى منفى است.",
                              "-13"=>"مبلغ برگشتى براى برگشت جزئى بيش از مبلغ برگشت نخورده رسيد ديجيتالى است.",
                              "-14"=>"چنين تراکنشى تعريف نشده است.",
                              "-15"=>"مبلغ برگشتى به صورت اعشارى داده شده است.",
                              "-16"=>"خطاى داخلى سيستم",
                              "-17"=>"برگشت زدن جزئى تراکنشى که با کارت بانکى غير از بانک سامان انجام پذيرفته است.",
                              "-18"=>"دسترسي فروشنده از IP غير مجاز"
    );

    if ($type == 1) {
      return $error_msg[$key];
    } elseif ($type == 2) {
      return $web_method_error[$key];
    }
  }
  
  function run() {
    if ($this->verifyresult <= 0) {
      return False;
    } elseif ($this->verifyresult > $this->amount) {
      return True;
    } elseif ($this->verifyresult < $this->amount) {
      return False;
    } else if ($this->verifyresult == $this->amount) {
      return True;
    }
  }

  function store() {

    if ($this->state == "OK") {
      if ($this->reference != '0' AND strlen($this->reference) == 20) {
        @$res = tep_db_query("SELECT id, used FROM " .SB24_TABLE_ERECEIPT. " WHERE refer_number='" .$this->reference. "'");
        @$numrow = tep_db_num_rows($res);
        if ($numrow == 0) {
          @tep_db_query("INSERT INTO " .SB24_TABLE_ERECEIPT. " VALUES ('','" .$this->orderid. "','" .$this->amount. "','" .$this->reference. "','" .$this->verifyresult. "','0','1')");
          $returnvalue = True;
        } elseif ($numrow == 1) {
          $row = tep_db_fetch_array($res);
          if ($row['used'] == 0) {
            $rowid = $row['id'];
            @tep_db_query("UPDATE " .SB24_TABLE_ERECEIPT. " SET used='1' WHERE id='$rowid'");
            $returnvalue = True;
          } else {
            $returnvalue = False;
          }
        } else {
          $returnvalue = False;
        }
      } else {
        $returnvalue = False;
      }
    } else {
      $returnvalue = False;
    }
    
    return $returnvalue;
  }

  function run_action() {
    
    switch($this->action) {
      case 'Delreser':
        $indbreser = tep_db_input($this->reservation);
        @$res = tep_db_query("SELECT id FROM " .SB24_TABLE_RESERVATION. " WHERE res_number='$indbreser'");
        if(@tep_db_num_rows($res) == 1) {
          $row = @tep_db_fetch_array($res);
          $resid = $row['id'];
          @tep_db_query("DELETE FROM " .SB24_TABLE_RESERVATION. " WHERE id=$resid");
          $action_status = True;
        } else {
          $action_status = False;
        }
        break;
      case 'CheckRefer':
        $indbrefer = tep_db_input($this->reference);
        @$res = tep_db_query("SELECT used FROM " .SB24_TABLE_ERECEIPT. " WHERE refer_number='$indbrefer'");
        @$num = tep_db_num_rows($res);
        if($num == 0) {
          $action_status = True;         
        } elseif($num == 1) {
          $row = tep_db_fetch_array($res);
          if($row['used'] == 0) {
            $action_status = True;       
          } else {
            $action_status = False;
          }
        } else {
          $action_status = False;
        }
        break;
      case 'Checkreser':
        $indbreser = tep_db_input($this->reservation);
        @$res = tep_db_query("SELECT orderid, amount FROM " .SB24_TABLE_RESERVATION. " WHERE res_number='$indbreser'");
        if(@tep_db_num_rows($res) == 1) {
          $row = tep_db_fetch_array($res);
          $this->amount = $row['amount'];
          $this->orderid = $row['orderid'];
          return True;
        } else {
          return False;
        }
        break;
      case 'VerifyMethod':
        $soapclient = new nusoap_client('https://acquirer.sb24.com/ref-payment/ws/ReferencePayment?WSDL','wsdl');
        $soapProxy = $soapclient->getProxy() ;
        
        $repeat = 0;
        do {
        $this->verifyresult = 0;
        $this->verifyresult =  $soapProxy->VerifyTransaction($this->reference,MERCHANT_ID);//reference number and sellerid
        $repeat++;
        } while($this->verifyresult == 0 AND $repeat < 3);
        if( $this->verifyresult <= 0 ) {
          return False;
       } else {
          return True;
        }
        break;
      default:
        $action_status = False;
        break;
    }

    return $action_status;
  }

  function save_error() {
    if ($this->error_ok == True) {
      for ($i=$this->error_save_handele;$i<sizeof($this->errorstr);$i++) {
        error_log($this->errorstr[$i]."\n",3,"includes/error.log");
      }
      $this->error_save_handele = $i;
    } else {
      $this->error_save_handele = 0;
    }
  }
}

class sb24return {

  var $reference = '0';                //Unique receipt Number from bank
  var $referid = 0;                    //records id of this reference in database
  var $allamount = 0;                  //all amount of transaction
  var $returnamount = 0;               //amount of transaction that you want returned
  var $orderid = 0;                    //ID of order for wist user and order
  var $verify = '';                    //state of transaction
  var $return_status = 0;              //status of reverse web method
  var $error_ok = False;
  var $errorstr = array();
  var $error_save_handele = 0;

  function sb24return($refer = '') {

    if(trim($refer) != '' AND strlen($refer) == 20) {

      $refer = tep_db_input($refer);
      @$res = tep_db_query("SELECT * FROM " .SB24_TABLE_ERECEIPT. " WHERE refer_number='$refer'");
      if(tep_db_num_rows($res) == 1) {

        $row = tep_db_fetch_array($res);
        if ($row['treturn'] == 0) {
          $this->orderid = $row['orderid'];
          $this->allamount = $row['amount'];
          $this->reference = $row['refer_number'];
          $this->verify = $row['verify'];
          $this->referid = $row['id'];
        } else {
          $this->errorstr[] = "Return back error: return action for this referenace number is not available.";
          $this->error_ok = True;
        }

      } else {
        $this->errorstr[] = "Return back error:  this referenace number can not be found in database.";
        $this->error_ok = True;
      }

    } else {
      $this->errorstr[] = 'Return back error: referenace number is invalid!';
      $this->error_ok = True;
    }
    $this->save_error();
  }
  
  function back($amount) {

    $this->returnamount = intval($amount);

    if($this->reference == '0' OR $this->orderid == 0 OR $this->verify <= 0 OR $this->error_ok == True) {
   	  return False;
    } else {
      $res = tep_db_query("SELECT  sum(ret_amount) as sum FROM " .SB24_TABLE_RETURNLOG. " WHERE erid='" .$this->referid. "' and error=1");
      $sum = 0;
      list($sum) = tep_db_fetch_array($res);

      if (($sum + $this->returnamount) <= $this->allamount) {

        $soapclient = new nusoap_client('http://Acquirer.sb24.com/ref-payment/ws/ReferencePayment?WSDL','wsdl');
        $soapProxy = $soapclient->getProxy() ;
        $result =  $soapProxy->ReverseTransaction($this->reference, MERCHANT_ID, MERCHANT_PASSWORD, $this->returnamount); //reference number,sellerid,password,reverse amount

        tep_db_query("INSERT INTO " .SB24_TABLE_RETURNLOG. " VALUES('', '" .$this->referid. "', '" .$this->returnamount. "', '" .$result. "')");

        if(($result == 1) AND (($sum + $this->returnamount) == $this->allamount)) {
          tep_db_query("UPDATE " .SB24_TABLE_ERECEIPT. " SET treturn='1' WHERE id='" .$this->referid. "'");
        }
        
        $this->return_status = $result;
        if( $result == 1 ) {
          return True;
        } else {
          return False;
        }
      } else {
      	$this->return_status = -13;
        return False;
      }
    }

  }
  
  function show_msg() {
    
  	$web_method_error = array("-1"=>"خطاى داخلى شبکه مالى",
                              "-2"=>"سپرده ها برابر نيستند.",
                              "-3"=>"ورودى ها حاوى کاراکترهاى غيرمجاز مى باشند.",
                              "-4"=>"Merchant Authentication Failed (کلمه عبور يا کد فروشنده اشتباه است).",
                              "-5"=>"Database Exception",
                              "-6"=>"سند قبلا برگشت کامل يافته است.",
                              "-7"=>"رسيد ديجيتالى تهى است.",
                              "-8"=>"طول ورودى ها بيشتر از حد مجاز است.",
                              "-9"=>"وجود کاراکترهاى غيرمجاز در در مبلغ برگشتى.",
                              "-10"=>"رسيد ديجيتالى به صورت Base64 نيست (حاوى کاراکترهاى غيرمجاز مى باشد).",
                              "-11"=>"طول ورودى ها کمتر از حد مجاز است.",
                              "-12"=>"مبلغ برگشتى منفى است.",
                              "-13"=>"مبلغ برگشتى براى برگشت جزئى بيش از مبلغ برگشت نخورده رسيد ديجيتالى است.",
                              "-14"=>"چنين تراکنشى تعريف نشده است.",
                              "-15"=>"مبلغ برگشتى به صورت اعشارى داده شده است.",
                              "-16"=>"خطاى داخلى سيستم",
                              "-17"=>"برگشت زدن جزئى تراکنشى که با کارت بانکى غير از بانک سامان انجام پذيرفته است.",
                              "-18"=>"دسترسي فروشنده از IP غير مجاز"
    );
    
    if($this->return_status < 0 AND $this->return_status > -18)
      return $web_method_error[$this->return_status];
    elseif($this->return_status == 1)
      return "عملیات برگشت زدن رسید دیجیتالی با موفقیت انجام شد.";
    else
      return "سیستم قادر به برگشت زدن این رسید دیجیتالی نمی باشد. برای اطلاعات بیشتر با مدیریت سایت تماس بگیرید.";
    
  }
  
  function save_error() {
    if ($this->error_ok == True) {
      for ($i=$this->error_save_handele;$i<sizeof($this->errorstr);$i++) {
        error_log($this->errorstr[$i]."\n",3,"includes/error.log");
      }
      $this->error_save_handele = $i;
    } else {
      $this->error_save_handele = 0;
    }
  }

}

//Random Password Generator  v1.0
//special tanks from sebflipper (http://www.sebflipper.com)
function generatePassword($plength,$include_letters,$include_capitals,$include_numbers,$include_punctuation) {

  $pwd = '';
  // First we need to validate the argument that was given to this function
  // If need be, we will change it to a more appropriate value.
  if(!is_numeric($plength) || $plength <= 0) {
    $plength = 8;
  }
  if($plength > 32) {
    $plength = 32;
  }

  // This is the array of allowable characters.
  $chars = "";

  if ($include_letters == true) { $chars .= 'abcdefghijklmnopqrstuvwxyz'; }
  if ($include_capitals == true) { $chars .= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'; }
  if ($include_numbers == true) { $chars .= '0123456789'; }
  if ($include_punctuation == true) { $chars .= '`??$%^&*()-_=+[{]};:@#~,<.>/?'; }

  // If nothing selected just display 0's
  if ($include_letters == false AND $include_capitals == false AND $include_numbers == false AND $include_punctuation == false) {
  $chars .= '0';
  }

  // This is important:  we need to seed the random number generator
  mt_srand(microtime() * 1000000);

  // Now we simply generate a random string based on the length that was
  // requested in the function argument
  for($i = 0; $i < $plength; $i++) {
    $key = mt_rand(0,strlen($chars)-1);
    $pwd = $pwd . $chars{$key};
  }

  // Finally to make it a bit more random, we switch some characters around
  for($i = 0; $i < $plength; $i++) {
    $key1 = mt_rand(0,strlen($pwd)-1);
    $key2 = mt_rand(0,strlen($pwd)-1);

    $tmp = $pwd{$key1};
    $pwd{$key1} = $pwd{$key2};
    $pwd{$key2} = $tmp;
  }

  // Convert into HTML
  $pwd = htmlentities($pwd, ENT_QUOTES);

  return $pwd;
}

//Close return action
function notreturn($refer = '') {
  if(trim($refer) != '' AND strlen($refer) == 20) {
    $refer = tep_db_input($refer);
    @$res = tep_db_query("SELECT id,treturn FROM " .SB24_TABLE_ERECEIPT. " WHERE refer_number='$refer'");
    if (@tep_db_num_rows($res) == 1) {
      $row = tep_db_fetch_array($res);
      if ($row['treturn'] == 0) {
        $rowid = $row['id'];
        tep_db_query("UPDATE " .SB24_TABLE_ERECEIPT. " SET treturn='1' WHERE id='$rowid'");
        $returnvalue = True;
      } else {
        $returnvalue = False;
      }
    } else {
      $returnvalue = False;
    }
  } else {
    $returnvalue = False;
  }
  return $returnvalue;
}

?>