<?php
/*
   $Id: founctions/farsi.php, v1.1 2009/07/20 13:53:30 Farhad zare & Samad kushan Exp $
   
  Virtu, Open Source E-Commerce
  http://www.e-virtu.com/

  Copyright (c) 2007-2009 Virtu E-Commerce

  Released under the GNU General Public License
*/

defined('PROJECT_VERSION') or die('Access denied!');

require('includes/functions/jdf.php');

define(HEJRI_ERROR, "پارامترهاي تابع تاريخ شمسي نادرست مي باشد.");

//easy convertor function for hejri date

//base convertor
function tep_formathejri($date) {
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $date, $datetime)) {
    return jdate("l، d F، Y", mktime(0,0,0,$datetime[2],$datetime[3],$datetime[1]));
  } else {
    return HEJRI_ERROR;
  }
}

function tep_hejri1($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $date, $datetime)) {
    return jdate("Y/m/d", mktime(0,0,0,$datetime[2],$datetime[3],$datetime[1]));
  } else {
    return HEJRI_ERROR;
  }
}

function tep_hejri2($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $date, $datetime)) {
    return jdate("d F، Y", mktime(0,0,0,$datetime[2],$datetime[3],$datetime[1]));
  } else {
    return HEJRI_ERROR;
  }
}

function tep_hejri3($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $date, $datetime)) {
    return jdate("H:i:s d-m-Y", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
  } else {
    return HEJRI_ERROR;
  }
}

function tep_hejri4($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $date, $datetime)) {
    return jdate("l، d F", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
  } else {
    return HEJRI_ERROR;
  }
}

function tep_hejri5($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{1,2})-([0-9]{1,2})-([0-9]{4})", $date, $datetime)) {
    return jdate("d-m-Y", mktime(0,0,0,$datetime[2],$datetime[1],$datetime[3]));
  } else {
    return HEJRI_ERROR;
  }
}

function tep_hejri6($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $date, $datetime)) {
    return jdate("d F، Y-H:i:s", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
  } else {
    return HEJRI_ERROR;
  }
}

// now date to hejri
function tep_nowhejri(){
  return jdate("l، d F، Y");
}

// long hejri date
function tep_hejri7($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $date, $datetime)) {
    return jdate("l، d F، Y H:i:s", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
  } else {
    return HEJRI_ERROR;
  }
}

//use of gregorian_to_jalali
function tep_hejri9($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $date, $datetime)) {
    $converted = gregorian_to_jalali($datetime[1], $datetime[2], $datetime[3]);
	return $converted[0] . '/' . $converted[1] . '/' . $converted[2];
  } else {
    return HEJRI_ERROR;
  }
}

//hejri to gregorian functions
function tep_back2format($date){
  if($date == null)
    return null;
  if (ereg ("([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})", $date, $datetime)) {
    $gredate = jalali_to_gregorian($datetime[1],$datetime[2],$datetime[3]);
    $date = sprintf("%02d",$gredate[1]) ."/". sprintf("%02d",$gredate[2]) ."/".$gredate[0];
    return $date;
  } else {
    return HEJRI_ERROR;
  }
}

//creates a pull_down list of hejri month
function tep_get_hejri_month($name, $selected = '') {

  $hejri_month_array = array(array('id' => '0', 'text' => PULL_DOWN_DEFAULT));

  for ($i=1, $n=13; $i<$n; $i++) {
    $hejri_month_array[] = array('id' => $i, 'text' => jdate("F",jmaketime(0,0,0,$i,1,1363)));
  }

  return tep_draw_pull_down_menu($name, $hejri_month_array, $selected);
}

//creates a pull_down list of month days
function tep_get_hejri_day($month, $name, $selected = '') {

  $hejri_day_array = array(array('id' => '1', 'text' => '01'));
  $n = jdate("t",jmaketime(0,0,0,$month,1,1383));
  for($i=2; $i<=$n; $i++) {
    $hejri_day_array[] = array('id' => $i, 'text' => sprintf("%02d",$i));
  }

  return tep_draw_pull_down_menu($name, $hejri_day_array, $selected);
}
?>