<?php
/*
  $Id: egold.php,v 1.0 2006/03/11 19:43:50 Farhad Zare Exp $

  Virtu, Open Source E-Commerce
  http://www.e-virtu.com/

  Copyright (c) 2007-2009 Virtu E-Commerce

  Released under the GNU General Public License
*/

  defined('PROJECT_VERSION') or die('Access denied!');

  class egold {
    var $code, $title, $description, $enabled;

// class constructor
    function egold() {
      global $order;

      $this->code = 'egold';
      $this->title = MODULE_PAYMENT_EGOLD_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_EGOLD_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_EGOLD_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_EGOLD_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_EGOLD_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_EGOLD_ORDER_STATUS_ID;
      }
      
      $this->units = MODULE_PAYMENT_EGOLD_UNITS;
      $this->metal_id = MODULE_PAYMENT_EGOLD_METAL_ID;
      
      if(($this->units == "Gram" OR $this->units == "Troy Ounce") AND $this->metal_id == "Buyer Choice")
        $this->metal_id = "Gold";  

      if (is_object($order)) $this->update_status();

      $this->form_action_url = 'https://www.e-gold.com/sci_asp/payments.asp';
    }

// class methods
//update status of module if module state selected
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_EGOLD_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_EGOLD_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

//validation entry data by user in payment form
    function javascript_validation() {
      return false;
    }

//show payment tile for select by user (or design form for geting required data of user)
    function selection() {
      $selection = array('id' => $this->code,
                         'module' => $this->title);
      return $selection;
    }

//checking entry data by user in payment form befor show next page
    function pre_confirmation_check() {
      return false;
    }

//show important data to user befor redirect user to payment site
    function confirmation() {
      return false;
    }

//run all actions and design form for send to payment site
    function process_button() {
      global $order, $currencies;
      
      $grams_per_ounce = 31.1034768; //constant
      $units_array = array( "US Dollar"=>array("USD", "1"),
                            "Euro"=>array("EUR", "85"),
                            "Gram"=>array("g", "8888"),
                            "Troy Ounce"=>array("oz", "9999"));
      $metal_array = array( "Buyer Choice"=>"0",
                            "Gold"=>"1",
                            "Silver"=>"2",
                            "Platinum"=>"3",
                            "Palladium"=>"4");

//if payment units is Gram or Troy Ounce then should get rate of metal for exchange order total money of USD to selected metal
      if($this->units == "Gram" OR $this->units == "Troy Ounce") {
        
      	// fetch the current value of gold
      	$queryURL = 'https://www.e-gold.com/unsecure/metaldata.asp?LATEST=1&CUR=USD&' . strtoupper($this->metal_id) . '=1'; // you can use http as well
      	
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $queryURL);
        curl_setopt ($ch, CURLOPT_TIMEOUT, 3);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec($ch);
        curl_close($ch);
        if (tep_not_null($result)) {
	      $result_array = explode(',', urldecode($result));
	      $result = trim($result_array[1]);
        } else {
          $this->units = "US Dollar";
        }
      
      }

//exchange order total money to selected unit
      if($this->units == "Troy Ounce") {
      	$amount = ($order->info['total']) * $currencies->currencies['USD']['value'];
      	$amount = $amount / $result;
      } elseif($this->units == "Gram") {
      	$amount = ($order->info['total']) * $currencies->currencies['USD']['value'];
      	$amount = ($amount / $result) * $grams_per_ounce;
      } else {
      	$amount = number_format(($order->info['total']) * $currencies->currencies[$units_array[$this->units][0]]['value'], $currencies->currencies[$units_array[$this->units][0]]['decimal_places']);
      }

//design hidden filed of form for pass to payment site
      $process_button_string = tep_draw_hidden_field('PAYEE_ACCOUNT', MODULE_PAYMENT_EGOLD_ACCOUNT) .
                               tep_draw_hidden_field('PAYEE_NAME', MODULE_PAYMENT_EGOLD_NAME) .
                               tep_draw_hidden_field('PAYMENT_AMOUNT', $amount) .
                               tep_draw_hidden_field('PAYMENT_UNITS', $units_array[$this->units][1]) .
                               tep_draw_hidden_field('PAYMENT_METAL_ID', $metal_array[$this->metal_id]) .
                               tep_draw_hidden_field('BAGGAGE_FIELDS', '') .
                               tep_draw_hidden_field('STATUS_URL', 'mailto:' . MODULE_PAYMENT_EGOLD_EMAIL) .
                               tep_draw_hidden_field('PAYMENT_URL', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
                               tep_draw_hidden_field('PAYMENT_URL_METHOD', 'POST') .
                               tep_draw_hidden_field('NOPAYMENT_URL', tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_EGOLD_ERROR_MESSAGE), 'SSL')) .
                               tep_draw_hidden_field('NOPAYMENT_URL_METHOD', 'LINK');
                               

      return $process_button_string;
    }

//parse all recieved data from payment site and verify transaction
    function before_process() {
      global $HTTP_POST_VARS;
      
      $grams_per_ounce = 31.1034768;
      $units_array = array( "1"=>"USD",
                            "85"=>"EUR",
                            "8888"=>"g",
                            "9999"=>"oz");
      $metal_array = array( "","GOLD","SILVER","PLATINUM","PALLADIUM");

      if (!isset($HTTP_POST_VARS['PAYEE_ACCOUNT']) || !isset($HTTP_POST_VARS['PAYMENT_AMOUNT']) || !isset($HTTP_POST_VARS['PAYMENT_UNITS']) || !isset($HTTP_POST_VARS['PAYMENT_BATCH_NUM']) || !isset($HTTP_POST_VARS['PAYER_ACCOUNT']))
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_EGOLD_ERROR_MESSAGE2), 'SSL'));
        
      $in_PAYEE_ACCOUNT = '';
      $in_PAYMENT_AMOUNT = '';
      $in_PAYMENT_UNITS = '';
      $in_PAYMENT_METAL_ID = '';
      $in_PAYMENT_BATCH_NUM = '';
      $in_PAYER_ACCOUNT = '';
      
      $in_PAYEE_ACCOUNT = urldecode($HTTP_POST_VARS['PAYEE_ACCOUNT']);
      $in_PAYMENT_AMOUNT = urldecode($HTTP_POST_VARS['PAYMENT_AMOUNT']);
      $in_PAYMENT_UNITS = urldecode($HTTP_POST_VARS['PAYMENT_UNITS']);
      $in_PAYMENT_METAL_ID = urldecode($HTTP_POST_VARS['PAYMENT_METAL_ID']);
      $in_PAYMENT_BATCH_NUM = urldecode($HTTP_POST_VARS['PAYMENT_BATCH_NUM']);
      $in_PAYER_ACCOUNT = urldecode($HTTP_POST_VARS['PAYER_ACCOUNT']);
      
      if($in_PAYEE_ACCOUNT != MODULE_PAYMENT_EGOLD_ACCOUNT)
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_EGOLD_ERROR_MESSAGE2), 'SSL'));

//for bug in system must order total money calculate again
      require_once(DIR_WS_CLASSES . 'order.php');
      require_once(DIR_WS_CLASSES . 'currencies.php');
      $temp_order = new order;
      $temp_currencies = new currencies;
      
      $temp_order->info['comments'] .= "\nBatch Number: ". $in_PAYMENT_BATCH_NUM;
      
//if payment units is Gram or Troy Ounce then should get rate of metal for exchange order total money of USD to selected metal
      if($in_PAYMENT_UNITS == "8888" OR $in_PAYMENT_UNITS == "9999") {
        
      	// fetch the current value of gold
      	$queryURL = 'https://www.e-gold.com/unsecure/metaldata.asp?LATEST=1&CUR=USD&' . $metal_array[$in_PAYMENT_METAL_ID] . '=1'; // you can use http as well
      	
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $queryURL);
        curl_setopt ($ch, CURLOPT_TIMEOUT, 3);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        $result = curl_exec($ch);
        curl_close($ch);
        if (tep_not_null($result)) {
	      $result_array = explode(',', urldecode($result));
	      $result = trim($result_array[1]);
        } else {
          return;
        }
      
      }
      
      if($in_PAYMENT_UNITS == "8888") {
        $amount = ($temp_order->info['total']) * $temp_currencies->currencies['USD']['value'];	
        $amount = (amount / $result) * $grams_per_ounce;
      } elseif($in_PAYMENT_UNITS == "9999") {
      	$amount = ($temp_order->info['total']) * $temp_currencies->currencies['USD']['value'];
      	$amount = $amount / $result;
      } else {
        $amount = number_format($temp_order->info['total'] * $temp_currencies->currencies[$units_array[$in_PAYMENT_UNITS]]['value'],  $temp_currencies->currencies[$units_array[$in_PAYMENT_UNITS]]['decimal_places']);
      }

      if($in_PAYMENT_AMOUNT != $amount)
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_EGOLD_ERROR_MESSAGE3), 'SSL'));

      
    }

//store needed data in database after payment process complated by system
    function after_process() {
      return false;
    }

//handle error massages
    function get_error() {
      return false;
    }

//check module is enable
    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EGOLD_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

//install data for run while module installed
    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('فعال کردن موژول e-Gold', 'MODULE_PAYMENT_EGOLD_STATUS', 'True', 'آیا شما تمایل به دریافت مبلغ سفارش از طریق E-Gold را دارید؟', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('اسم صاحب حساب e-Gold', 'MODULE_PAYMENT_EGOLD_NAME', 'نام فروشگاه', 'اسمی که شما تمایل به نمایش آن در سایت e-gold به هنگام پرداخت پول را دارید.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('شماره حساب e-Gold', 'MODULE_PAYMENT_EGOLD_ACCOUNT', '0000000', 'شماره حساب شما در e-gold که تمایل دارید مبلغ سفارش به این شماره حساب واریز گردد.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('آدرس پست الکترونیکی', 'MODULE_PAYMENT_EGOLD_EMAIL', 'admin@localhost', 'پس از اتمام عملیات پرداخت پول نامه‌ای از طرف سایت e-gold به این آدرس دریافت خواهید کرد که حاوی کلیه اطلاعات در رابطه با پرداخت پول می‌باشد.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('واحد پرداخت پول', 'MODULE_PAYMENT_EGOLD_UNITS', 'US Dollar', 'شما تمایل دارید که مبلغ سفارش در چه واحد پولی به حساب شما واریز گردد؟', '6', '0', 'tep_cfg_select_option(array(\'US Dollar\', \'Euro\', \'Gram\', \'Troy Ounce\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('فلز مورد معامله', 'MODULE_PAYMENT_EGOLD_METAL_ID', 'Gold', 'شما تمایل دارید که به هنگام پرداخت پول از چه نوع فلزی استفاده شود؟', '6', '0', 'tep_cfg_select_option(array(\'Buyer Choice\', \'Gold\', \'Silver\', \'Platinum\', \'Palladium\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('مرتبه طبقه بندی برای نمایش.', 'MODULE_PAYMENT_EGOLD_SORT_ORDER', '0', 'مرتبه طبقه‌بندی برای نمایش دادن. مقادیر کمتر بالاتر نمایش داده می‌شوند.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('منطقه پرداخت', 'MODULE_PAYMENT_EGOLD_ZONE', '0', 'اکر منطقه‌ای انتخاب شود این روش پرداخت فقط برای آن منطقه فعال خواهد بود.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('تنظیم وضعیت نمایش', 'MODULE_PAYMENT_EGOLD_ORDER_STATUS_ID', '0', 'وضعیت سفارشاتی که با این روش پرداخت می‌شوند روی این مقدار تنظیم شود.', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

//remove data from database while module removed
    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

//all keys defined in install function
    function keys() {
      return array('MODULE_PAYMENT_EGOLD_STATUS', 'MODULE_PAYMENT_EGOLD_NAME', 'MODULE_PAYMENT_EGOLD_ACCOUNT','MODULE_PAYMENT_EGOLD_EMAIL' , 'MODULE_PAYMENT_EGOLD_UNITS', 'MODULE_PAYMENT_EGOLD_METAL_ID', 'MODULE_PAYMENT_EGOLD_SORT_ORDER', 'MODULE_PAYMENT_EGOLD_ZONE', 'MODULE_PAYMENT_EGOLD_ORDER_STATUS_ID');
    }
  }
?>