<?php
/*
  $Id: iranlpost.php,v 1.0 2007/03/12 02:07:11 farhad zare Exp $

  Virtu, Open Source E-Commerce
  http://www.e-virtu.com/

  Copyright (c) 2006-2007 Virtu E-Commerce

  Released under the GNU General Public License
*/

  defined('PROJECT_VERSION') or die('Access denied!');

  class iranlpost {
    var $code, $title, $description, $icon, $enabled;

// class constructor
    function iranlpost() {
      global $order;

      $this->code = 'iranlpost';
      $this->title = MODULE_SHIPPING_IRAN_LPOST_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_IRAN_LPOST_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_SHIPPING_IRAN_LPOST_SORT_ORDER;
      $this->icon = '';
      $this->costs_file = MODULE_SHIPPING_IRAN_LPOST_COST;
      $this->enabled = ((MODULE_SHIPPING_IRAN_LPOST_STATUS == 'True') ? true : false);
      
      if ( ($this->enabled == true) && (!file_exists($this->costs_file))) {
      	$this->enabled = false;
      }

      if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_IRAN_LPOST_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_IRAN_LPOST_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

// class methods
    function quote($method = '') {
      global $order, $cart, $shipping_weight, $shipping_num_boxes;

      $pointer = fopen($this->costs_file, "r");
      $table_costs = array();
      while ( !feof($pointer) ) {
        $fline = fgets($pointer);
        $table_costs[] = explode(":", $fline);
      }
      fclose($pointer);

      $sizetc = sizeof($table_costs);
      $minvalue = 100000;
      for ($i=0; $i<$sizetc; $i++) {
        if ( ($shipping_weight <= $table_costs[$i][0]) && ($table_costs[$i][0] < $minvalue) ) {
          $minvalue = $table_costs[$i][0];
          $shipping = $table_costs[$i][1];
        }
      }
      
      if ($minvalue == 100000) {
      	$shipping = $table_costs[$sizetc-1][1];
      }

      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_IRAN_LPOST_TEXT_TITLE,
                            'methods' => array(array('id' => $this->code,
                                                     'title' => MODULE_SHIPPING_IRAN_LPOST_TEXT_WAY,
                                                     'cost' => $shipping + MODULE_SHIPPING_IRAN_LPOST_BASECOST)));

      if (tep_not_null($this->icon)) $this->quotes['icon'] = tep_image($this->icon, $this->title);

      return $this->quotes;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_IRAN_LPOST_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('فعال کردن پست پیشتاز', 'MODULE_SHIPPING_IRAN_LPOST_STATUS', 'True', 'آیا مایلید که برای ارسال سفارشات از پست پیشتاز داخلی استفاده کنید؟', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('مسیر جدول نرخها', 'MODULE_SHIPPING_IRAN_LPOST_COST', 'includes/modules/shipping/iran_lpost.txt', 'کلیه نرخها باید در فایلی وارد شود. در هر سطر فایل یک نرخ وارد می شود که وزن و مبلغ با یک : از هم جدا می شوند.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('هزینه ثابت', 'MODULE_SHIPPING_IRAN_LPOST_BASECOST', '0', 'مقدار مبلغی که به کل هزینه محاسبه شده اضافه خواهد شد.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('منطقه حمل و نقل', 'MODULE_SHIPPING_IRAN_LPOST_ZONE', '0', 'اگر منطقه اي را انتخاب كنيد, اين روش حمل و نقل فقط براي آن منطقه فعال خواهد بود.', '6', '0', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('مرتبه طبقه بندی', 'MODULE_SHIPPING_IRAN_LPOST_SORT_ORDER', '0', 'مرتبه طبقه بندي براي نمايش دادن.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_IRAN_LPOST_STATUS', 'MODULE_SHIPPING_IRAN_LPOST_COST', 'MODULE_SHIPPING_IRAN_LPOST_BASECOST', 'MODULE_SHIPPING_IRAN_LPOST_ZONE', 'MODULE_SHIPPING_IRAN_LPOST_SORT_ORDER');
    }
  }
?>
